#include <bits/stdc++.h>
#define ll long long
using namespace std;
int main()
{
ll N,Q,c,z,x,zbir=0;
	cin >> N >> Q;
vector<ll> d(N),p(N),k(N);
	for(int i=0;i<N;i++)
		{
			cin >> d[i] >> p[i];
			zbir=zbir+p[i];
		}
	for(int i=0;i<Q;i++)
	{
		cin >> k[i];	
	}
	
		for(int i=0;i<Q;i++)
	{  
	z=0;c=0;x=0;
		if(k[i]>zbir) 
			{
				cout << zbir;
				break;
			}
		for(int j=0;j<=k[i];j++)
		{
		
			if(j==d[c])
			{
				x+=p[c];
				c++;
			}
			if(x>0)
			{
				z++;
				x--;
			}
		}
		cout << z << endl;
	}
 return 0;
}